#===============================================================================
#Variables
#===============================================================================
RARC_VERSION="1.0.0.3"
URL_UPDATE="t29.tomba.fccn.pt:8080/rarc/update/?v="
URL_DOWNLOAD="t29.tomba.fccn.pt:8080/rarc/download/"
RARC_SINSTALL_TAR="rArcSInstall.tar"
RARC_SINSTALL="rArcSInstall.sh"
WGET_UPDATE_LOG="wget_update.log"
WGET_DOWNLOAD_LOG="wget_download.log"
UPDATE_LOG="rArcUpdate.log"
SLEEP_DAY="86400"
TIMEOUT="600"
WAIT="60"


#===============================================================================
clean_files()
#Function: 
#Returns:
#===============================================================================
{

if [ -f $UPDATE_LOG ]; then
	rm -f $UPDATE_LOG
fi

if [ -f $WGET_DOWNLOAD_LOG ]; then
	rm -f $WGET_DOWNLOAD_LOG
fi

if [ -f $WGET_UPDATE_LOG ]; then
	rm -f $WGET_UPDATE_LOG
fi

if [ -f $RARC_SINSTALL_TAR ]; then
	rm -f $RARC_SINSTALL_TAR
fi

if [ -f $RARC_SINSTALL ]; then
	rm -f $RARC_SINSTALL
fi


}

#===============================================================================
kill_rArc_processes()
#Function: 
#Returns:
#===============================================================================
{

PID=`ps -e -f | grep rArcSetup | awk '/java -jar/' | awk '{ print $2 }'`
if [ $PID -gt 0 ]; then
	kill -9 $PID
fi

PID=`ps -e -f | grep rArc | awk '/java -jar/' | awk '{ print $2 }'`
if [ $PID -gt 0 ]; then
	kill -9 $PID
fi

}


#===============================================================================
#MAIN
#===============================================================================

sleep $WAIT

LOCKFILE="rArcUpdate.lock"

if [ -f $LOCKFILE ] ; then

	PID_RARC_UPDATE=`awk '{ print $0}' $LOCKFILE`
	kill -9 $PID_RARC_UPDATE
fi

echo $$ > $LOCKFILE

while [ 1 ]
do

	clean_files

	DATE_NOW=`date`
	echo "---Begins rArc update---"> $UPDATE_LOG
	echo "($DATE_NOW)Verify rArc version">> $UPDATE_LOG
	wget -S --spider -o $WGET_UPDATE_LOG  $URL_UPDATE$RARC_VERSION

	HTTP_CODE_UPDATE=`cat $WGET_UPDATE_LOG | grep "HTTP/" | awk '{print $2}'`

	if [ $HTTP_CODE_UPDATE -eq 200 ]; then # rARC is updated

			DATE_NOW=`date`
			echo "($DATE_NOW)Sleep 24 horas">> $UPDATE_LOG
			sleep $SLEEP_DAY

	elif [ $HTTP_CODE_UPDATE -eq 410 ] # rARC is not updated
	then
		
		DATE_NOW=`date`
		echo "($DATE_NOW)Get rArcSInstall">> $UPDATE_LOG
		wget -o $WGET_DOWNLOAD_LOG -S $URL_DOWNLOAD$RARC_SINSTALL_TAR
		
		HTTP_CODE_DOWNLOAD=`cat $WGET_DOWNLOAD_LOG | grep "HTTP/" | awk '{print $2}'`

		if [ $HTTP_CODE_DOWNLOAD -eq 200 ]; then

			DATE_NOW=`date`
			echo "($DATE_NOW)Kill rArc and rArcSetup processes">> $UPDATE_LOG
			kill_rArc_processes

			DATE_NOW=`date`
			echo "($DATE_NOW)Unzip the rArcSInstall.tar">> $UPDATE_LOG
			tar -xf $RARC_SINSTALL_TAR

			DATE_NOW=`date`
			echo "($DATE_NOW)Delete rArcSInstall.tar">> $UPDATE_LOG
			rm -rf $RARC_SINSTALL_TAR
		
			DATE_NOW=`date`
			echo "($DATE_NOW)Launch rArcSInstall.sh">> $UPDATE_LOG
			chmod +x $RARC_SINSTALL
			./$RARC_SINSTALL &
	
			break
		else

			DATE_NOW=`date`
			echo "($DATE_NOW)Problems to download rArcSInstall.tar">> $UPDATE_LOG
			echo "($DATE_NOW)Sleep 10 minutes">> $UPDATE_LOG
			sleep $TIMEOUT
		fi
	else
		DATE_NOW=`date`
		echo "($DATE_NOW)Sleep 10 minutes">> $UPDATE_LOG
		sleep $TIMEOUT
	fi

	clean_files
done

clean_files

rm -f $LOCKFILE

exit


