#!/bin/sh

#===============================================================================
#Variables
#===============================================================================
RARC_VERSION="1.0.0.3"
RARC="rArc.jar"
RARC_SETUP="rArcSetup.jar"
RARC_UPDATE="rArcUpdate.jar"
RARC_MENU_ITEM="rArc.desktop"
EXECUTE_FOLDER=`pwd`

#===================================================================
remove_files()
#Function: 
#Returns:
#===================================================================
{

cd $EXECUTE_FOLDER

rm -f configuration
rm -f register
rm -f identifier

rm -rf *.cap
rm -rf *.sh
rm -rf *.log
rm -rf *.jar
rm -rf *.txt

rm -rf libs/*
rmdir libs

rm -rf icon/*
rmdir icon

rm -rf $EXECUTE_FOLDER

}



#===================================================================
remove_rArc_shortcut()
#Function: 
#Returns:
#===================================================================
{

FOLDER_MAIN_MENU=".local/share/applications"

cd "$HOME/$FOLDER_MAIN_MENU"

if [ -f $RARC_MENU_ITEM ]; then
	rm -f $RARC_MENU_ITEM
fi

}


#===================================================================
delete_rArc_startup()
#Function: 
#Returns:
#===================================================================
{

cd $HOME/.config/autostart/

if [ -f "rArc.desktop" ]; then
	rm rArc.desktop
fi

if [ -f "rArcUpdate.desktop" ]; then
	rm -f rArcUpdate.desktop
fi

}

#===================================================================
delete_launch_scripts()
#Function: 
#Returns:
#===================================================================
{

cd $EXECUTE_FOLDER

if [ -f "rArc.sh" ]; then
	rm rArc.sh
fi

if [ -f "rArcSetup.sh" ]; then
	rm rArcSetup.sh
fi

if [ -f "rArcUpdate.sh" ]; then
	rm rArcUpdate.sh
fi

}

#===================================================================
kill_rArc_processes()
#Function: 
#Returns:
#===================================================================
{

PID=`ps -e -f | grep rArcSetup | awk '/java -jar/' | awk '{ print $2 }'`
if [ $PID > 0 ]; then
	kill -9 $PID
fi

PID=`ps -e -f | grep rArcUpdate | awk '/sh/' | awk '{ print $2 }'`
if [ $PID > 0 ]; then
	kill -9 $PID
fi

PID=`ps -e -f | grep rArc | awk '/java -jar/' | awk '{ print $2 }'`
if [ $PID > 0 ]; then
	kill -9 $PID
fi

}


#===================================================================
#MAIN
#===================================================================

echo "Stop rArc programs...OK"
kill_rArc_processes

echo "Delete launch scripts...OK"
delete_launch_scripts

echo "Delete rArc startup...OK"
delete_rArc_startup

echo "Delete files of rArc..OK"
remove_files

echo "Delete rArc shurtcut..OK"
remove_rArc_shortcut

echo "DONE!!!"
exit
